#include "mod_basic.h"

/* Note on modules and rosters
 * the server has a built in roster management setup,
 * to use it, a module adds all the user's rosters whenever a new session comes online with session_roster()
 * and then just listens for the add/delete calls and modifies it's own database, the session will manage it's own and respond to gets
 * OTHERWISE, catch add/del/get and set result=M_HANDLED and modify the xml appropriately for the response
 */

void mod_basic_roster_load(char *user)
{
    xmlnode x, group, item;

    if(user == NULL)
        return;

    jdebug(ZONE,"MOD_BASIC: %s roster load",user);

    x = mod_basic_data_manager(user,NULL);
    group = xmlnode_get_firstchild(xmlnode_get_tag(x,"roster"));
    while(group != NULL)
    {
        if(j_strcmp(xmlnode_get_name(group),"group") == 0)
            item = xmlnode_get_firstchild(group);
        else
            item = NULL;

        while(item != NULL)
        {
            if(j_strcmp(xmlnode_get_name(item),"item") == 0)
                roster_load(user,xmlnode_get_attrib(group,"name"),xmlnode_get_attrib(item,"jid"),xmlnode_get_data(xmlnode_get_firstchild(item)));
            item = xmlnode_get_nextsibling(item);
        }

        group = xmlnode_get_nextsibling(group);
    }
    xmlnode_free(x);
}

void mod_basic_roster_save(char *user, xmlnode r)
{
    /* XXX load the users xml file, if the rosters are different hide the old roster element, make a new one and copy the roster into it, then save it back out */
    xmlnode x, old;

    if(user == NULL || r == NULL)
        return;

    jdebug(ZONE,"MOD_BASIC: %s roster load",user);

    x = mod_basic_data_manager(user,NULL);
    old = xmlnode_get_tag(x,"roster");
    if(xmlnode_cmp(old,r) != 0)
    {
        xmlnode_hide(old);
        xmlnode_insert_node(x,r);
        mod_basic_data_manager(user,x);
    }
    xmlnode_free(x);
}
